unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Uart, ComCtrls;

type
  TMyThread = class(TThread)
    protected
      procedure Execute; override;
end;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Button_CloseCOM: TButton;
    Button_OpenCOM: TButton;
    Combo_COMPort: TComboBox;
    Combo_COMData: TComboBox;
    Combo_COMParity: TComboBox;
    Combo_COMStop: TComboBox;
    Combo_COMBaud: TComboBox;
    Button_Exit: TButton;
    GroupBox2: TGroupBox;
    Label13: TLabel;
    Label14: TLabel;
    Label4: TLabel;
    Label3: TLabel;
    Label12: TLabel;
    Label11: TLabel;
    Label10: TLabel;
    Label9: TLabel;
    Label8: TLabel;
    Label7: TLabel;
    Label6: TLabel;
    Label5: TLabel;
    Edit_MsgID: TEdit;
    Edit_MODE: TEdit;
    Edit_RTR: TEdit;
    Edit_DLC: TEdit;
    Edit_D0: TEdit;
    Edit_D1: TEdit;
    Edit_D2: TEdit;
    Edit_D3: TEdit;
    Edit_D4: TEdit;
    Edit_D5: TEdit;
    Edit_D6: TEdit;
    Edit_D7: TEdit;
    Button_Send: TButton;
    SendEdit: TEdit;
    CANCheckBox: TCheckBox;
    GroupBox3: TGroupBox;
    ListView1: TListView;
    Button_Clear: TButton;
    procedure Combo_COMPortChange(Sender: TObject);
    procedure Combo_COMBaudChange(Sender: TObject);
    procedure Combo_COMDataChange(Sender: TObject);
    procedure Combo_COMParityChange(Sender: TObject);
    procedure Combo_COMStopChange(Sender: TObject);
    procedure Button_ExitClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button_OpenCOMClick(Sender: TObject);
    procedure Button_CloseCOMClick(Sender: TObject);
    procedure Button_SendClick(Sender: TObject);
    procedure Edit_MODEChange(Sender: TObject);
    procedure Button_ClearClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }

    t1:TMyThread;
  end;

var
  Form1: TForm1;
  IsCOMOpen: boolean;
  cPort: Integer;
  cData: Integer;
  cStop: Integer;
  cParity: Integer;
  dwBaudRate: DWord;
  RxMsgCnt: DWord;


implementation

{$R *.dfm}

procedure TForm1.Combo_COMPortChange(Sender: TObject);
begin
  case Combo_COMPort.ItemIndex of
    0: begin  cPort := 1;  end;
    1: begin  cPort := 2;  end;
    2: begin  cPort := 3;  end;
    3: begin  cPort := 4;  end;
    4: begin  cPort := 5;  end;
    5: begin  cPort := 6;  end;
    6: begin  cPort := 7;  end;
    7: begin  cPort := 8;  end;
    8: begin  cPort := 9;  end;
    else begin  cPort := 1;  end;
  end;
end;

procedure TForm1.Combo_COMBaudChange(Sender: TObject);
begin
  case Combo_COMBaud.ItemIndex of
    0: begin  dwBaudRate := 9600;  end;
    1: begin  dwBaudRate := 19200;  end;
    2: begin  dwBaudRate := 38400;  end;
    3: begin  dwBaudRate := 57600;  end;
    4: begin  dwBaudRate := 115200;  end;
    5: begin  dwBaudRate := 230400;  end;
    6: begin  dwBaudRate := 460800;  end;
    7: begin  dwBaudRate := 921600;  end;
    else begin  dwBaudRate := 921600;  end;
  end;
end;

procedure TForm1.Combo_COMDataChange(Sender: TObject);
begin
  case Combo_COMData.ItemIndex of
    0: begin  cData := 5;  end;
    1: begin  cData := 6;  end;
    2: begin  cData := 7;  end;
    3: begin  cData := 8;  end;
    else begin  cData := 8;  end;
  end;
end;

procedure TForm1.Combo_COMParityChange(Sender: TObject);
begin
  case Combo_COMParity.ItemIndex of
    0: begin  cParity := 0;  end;
    1: begin  cParity := 1;  end;
    2: begin  cParity := 2;  end;
    else begin  cParity := 0;  end;
  end;
end;

procedure TForm1.Combo_COMStopChange(Sender: TObject);
begin
  case Combo_COMStop.ItemIndex of
    0: begin  cStop := 0;  end;
    1: begin  cStop := 1;  end;
    2: begin  cStop := 2;  end;
    else begin  cStop := 0;  end;
  end;
end;

procedure TForm1.Button_ExitClick(Sender: TObject);
begin
  if IsCOMOpen=true then
    begin
      IsCOMOpen:=false;
      t1.Terminate;
      Sleep(500);
      Close_Com(cPort);
      Sleep(500);
    end;
    
  Close();
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Combo_COMPort.ItemIndex:=0;
  Combo_COMBaud.ItemIndex:=4;
  Combo_COMData.ItemIndex:=3;
  Combo_COMParity.ItemIndex:=0;
  Combo_COMStop.ItemIndex:=0;
  cPort:=1;
  dwBaudRate:=115200;
  cData:=8;
  cParity:=0;
  cStop:=0;
end;

procedure TForm1.Button_OpenCOMClick(Sender: TObject);
var ret:Integer;

begin

  ret:=Open_Com(cPort,dwBaudRate,cData,cParity,cStop);
  if ret=0 then
    begin
      IsCOMOpen := true;
      Button_OpenCOM.Enabled:=false;
      Button_CloseCOM.Enabled:=true;
      Combo_COMPort.Enabled:=false;
      Combo_COMBaud.Enabled:=false;
      Combo_COMData.Enabled:=false;
      Combo_COMParity.Enabled:=false;
      Combo_COMStop.Enabled:=false;
      Button_Send.Enabled:=true;

      t1:=TMyThread.Create(false);
    end
  else
    begin
      IsCOMOpen := false;
      Button_OpenCOM.Enabled:=true;
      Button_CloseCOM.Enabled:=false;
      Button_Send.Enabled:=false;

      MessageDlg('Open_Com '+IntToStr(cPort)+' Error!, ret='+ IntToStr(ret), mtError , [mbOK], 0);
    end;
end;

procedure TForm1.Button_CloseCOMClick(Sender: TObject);
begin
  if IsCOMOpen=true then
  begin
    t1.Terminate;
    sleep(500);
    Close_Com(cPort);
    sleep(500);
    Button_OpenCOM.Enabled:=true;
    Button_CloseCOM.Enabled:=false;

    Combo_COMPort.Enabled:=true;
    Combo_COMBaud.Enabled:=true;
    Combo_COMData.Enabled:=true;
    Combo_COMParity.Enabled:=true;
    Combo_COMStop.Enabled:=true;
    IsCOMOpen:=false;
  end;
end;



procedure TForm1.Button_SendClick(Sender: TObject);
var send:string;
    NumCheck:Integer;
    DLC:Integer;
begin
  if Edit_MsgID.Text='' then
    Edit_MsgID.Text:='000';

  NumCheck:= StrToInt('$'+Edit_MsgID.Text);
  if (CANCheckBox.Checked) then
    begin
      if Edit_MODE.Text='' then  Edit_MODE.Text:='0';
      if Edit_RTR.Text='' then  Edit_RTR.Text:='0';

      if Edit_MODE.Text='0' then
        begin
          if Edit_RTR.Text='0' then
            send:='t'
          else
            send:='T';

          if NumCheck>2047 then
            NumCheck:=2047;

          send:=send+IntToHex(NumCheck, 3);
        end
      else
        begin
          if Edit_RTR.Text='0' then
            send:='e'
          else
            send:='E';

          if NumCheck>536870911 then
            NumCheck:=536870911;
          send:=send+IntToHex(NumCheck, 8);
        end;

      if Edit_DLC.Text='' then  Edit_DLC.Text:='0';
      if (StrToInt(Edit_DLC.Text)>8) then  Edit_DLC.Text:='0';
      
      send:=send+Edit_DLC.Text;

      if Edit_RTR.Text='0'then
        begin
          DLC:=StrToInt(Edit_DLC.Text);
          if (DLC>0) then
            begin
              if (Edit_D0.Text='') then
                Edit_D0.Text:='00';
              NumCheck:=StrToInt('$'+Edit_D0.Text);
              send:=send+IntToHex(NumCheck, 2);
            end;
          if (DLC>1) then
            begin
              if (Edit_D1.Text='') then
                Edit_D1.Text:='00';
              NumCheck:=StrToInt('$'+Edit_D1.Text);
              send:=send+IntToHex(NumCheck, 2);
            end;
          if (DLC>2) then
            begin
              if (Edit_D2.Text='') then
                Edit_D2.Text:='00';
              NumCheck:=StrToInt('$'+Edit_D2.Text);
              send:=send+IntToHex(NumCheck, 2);
            end;
          if (DLC>0) then
            begin
              if (Edit_D3.Text='') then
                Edit_D3.Text:='00';
              NumCheck:=StrToInt('$'+Edit_D3.Text);
              send:=send+IntToHex(NumCheck, 2);
            end;
          if (DLC>4) then
            begin
              if (Edit_D4.Text='') then
                Edit_D4.Text:='00';
              NumCheck:=StrToInt('$'+Edit_D4.Text);
              send:=send+IntToHex(NumCheck, 2);
            end;
          if (DLC>5) then
            begin
              if (Edit_D5.Text='') then
                Edit_D5.Text:='00';
              NumCheck:=StrToInt('$'+Edit_D5.Text);
              send:=send+IntToHex(NumCheck, 2);
            end;
          if (DLC>6) then
            begin
              if (Edit_D6.Text='') then
                Edit_D6.Text:='00';
              NumCheck:=StrToInt('$'+Edit_D6.Text);
              send:=send+IntToHex(NumCheck, 2);
            end;
          if (DLC>7) then
            begin
              if (Edit_D7.Text='') then
                Edit_D7.Text:='00';
              NumCheck:=StrToInt('$'+Edit_D7.Text);
              send:=send+IntToHex(NumCheck, 2);
            end;
        end;

      SendEdit.Text:=send;
      Send_Cmd(cPort,PChar(send),0);
    end
  else
    begin
      send:=SendEdit.Text;
      Send_Cmd(cPort,PChar(send),0);
    end;
end;

procedure TForm1.Edit_MODEChange(Sender: TObject);
begin
  if Edit_MODE.Text='0' then
    Edit_MsgID.MaxLength:=3
  else
    Edit_MsgID.MaxLength:=8;
end;

procedure TMyThread.Execute;
var receive:string;
    Str:string;
    RxdataNum:DWord;

    ret:Word;
    wT:Word;
    wTimeOut:Word;
    wChksum:Word;

    ListItem:TListItem;
    IsCorrectMsg:boolean;
    Data:array[0..7] of Integer;

    Mode:Integer;
    RTR:Integer;
    DataLen:Integer;
    i:Integer;
    MsgID:DWord;
begin
    SetLength(receive,100);
    wTimeOut:=10;
    wChksum:=0;
    Mode:=0;
    RTR:=0;
    DataLen:=0;
    MsgID:=0;

    while not Terminated do
      begin
        if IsCOMOpen then
          begin
            RxdataNum:=DataSizeInCom(cPort);
            if (RxdataNum > 0) then
            begin
              ret:=Receive_Cmd(cPort,PChar(receive),wTimeOut,wChksum,wT);
              if (ret=0) then
                begin
                   case receive[1] of
                     't':
                        begin
                          Mode:=0;
                          MsgID:=StrToInt('$'+ Copy(receive,2,3));
                          RTR:=0;
                          DataLen:=StrToInt('$'+ Copy(receive,5,1));
                          if DataLen>0 then
                            begin
                              for i:=0 to (DataLen-1) do
                                begin
                                  Data[i]:=StrToInt('$'+ Copy(receive,6+i*2,2));
                                end;
                            end;
                          IsCorrectMsg:=true;
                        end;
                     'T':
                        begin
                          Mode:=0;
                          MsgID:=StrToInt('$'+ Copy(receive,2,3));
                          RTR:=1;
                          DataLen:=StrToInt('$'+ Copy(receive,5,1));
                          IsCorrectMsg:=true;
                        end;
                     'e':
                        begin
                          Mode:=1;
                          MsgID:=StrToInt('$'+ Copy(receive,2,8));
                          RTR:=0;
                          DataLen:=StrToInt('$'+ Copy(receive,10,1));
                          if DataLen>0 then
                            begin
                              for i:=0 to (DataLen-1) do
                                begin
                                  Data[i]:=StrToInt('$'+ Copy(receive,11+i*2,2));
                                end;
                            end;
                          IsCorrectMsg:=true;
                        end;
                     'E':
                        begin
                          Mode:=1;
                          MsgID:=StrToInt('$'+ Copy(receive,2,8));
                          RTR:=1;
                          DataLen:=StrToInt('$'+ Copy(receive,10,1));
                          IsCorrectMsg:=true;
                        end;
                      else
                        begin  IsCorrectMsg:=false;  end;
                   end;

                   if IsCorrectMsg then
                    begin
                      Form1.ListView1.Tag := 0; //Disable Change Event
                      ListItem := Form1.ListView1.Items.Add();

                      Str:=Format('%d',[RxMsgCnt]);
                      ListItem.Caption := Str; //Handle No

                      if Mode=1 then
                        Str:='29-Bit'
                      else
                        Str:='11-Bit';
                        
                      ListItem.SubItems.Add(Str);  //Mode

                      Str:=Format('%X',[MsgID]);
                      ListItem.SubItems.Add(Str); //MsgID

                      if RTR=1 then
                        Str:='Y'
                      else
                        Str:='N';

                      ListItem.SubItems.Add(Str); //RTR

                      Str:=Format('%d',[DataLen]);
                      ListItem.SubItems.Add(Str); //DataLen

                      if (DataLen>0) then
                        begin
                          for i:=0 to (DataLen-1) do
                            begin
                             if (i < DataLen) and (RTR = 0) then
                                Str:=Format('%02X',[Data[i]])
                              else
                                Str:='';
                             ListItem.SubItems.Add(Str);
                            end;
                        end;

                      RxMsgCnt:=RxMsgCnt+1;
                      Form1.ListView1.Tag := 1;
                      Form1.ListView1.Scroll(0,10);

                      if(Form1.ListView1.Items.Count>500) then
                        begin
                          Form1.ListView1.Items.Clear();
                          RxMsgCnt:=0;
                        end;
                    end;
                end;
            end;
          end;
        Sleep(1);
      end

end;


procedure TForm1.Button_ClearClick(Sender: TObject);
begin
  if Form1.ListView1.Tag = 1 then
    begin
      ListView1.Items.Clear();
      RxMsgCnt:=0;
    end;

end;

end.
